#ifndef SBK_KNotificationWrapper_H
#define SBK_KNotificationWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <knotification.h>

namespace PySide { class DynamicQMetaObject; }

class KNotificationWrapper : public KNotification
{
public:
    KNotificationWrapper(const KNotificationWrapper &) = delete;
    KNotificationWrapper& operator=(const KNotificationWrapper &) = delete;
    KNotificationWrapper(KNotificationWrapper &&) = delete;
    KNotificationWrapper& operator=(KNotificationWrapper &&) = delete;

    KNotificationWrapper(const ::QString & eventId, ::QFlags<KNotification::NotificationFlag> flags = KNotification::NotificationFlag::CloseOnTimeout, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KNotificationWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_KNotificationWrapper_H

